---
title: ClipboardItem.getType()
slug: Web/API/ClipboardItem/getType
tags:
  - Clipboard
  - Clipboard API
  - ClipboardItem
  - Cut
  - Method
  - copy
  - getTypes
  - paste
---
<div>{{draft}}{{DefaultAPISidebar("Clipboard API")}}</div>

<p class="summary"><span class="seoSummary">The <strong><code>getType()</code></strong> method of the {{domxref("ClipboardItem")}} interface returns a {{jsxref("Promise")}} that resolves with a {{domxref("Blob")}} of the requested  {{Glossary("MIME type")}} or an error if the MIME type is not found.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <em>blob</em> = <em>clipboardItem</em>.getType(type);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>type</code></dt>
 <dd>A valid {{Glossary("MIME type")}}.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{domxref("Promise")}} that resolves with a {{domxref("Blob")}} object.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>DOMException</code></dt>
 <dd>The <code>type</code> does not match a known {{Glossary("MIME type")}}.</dd>
 <dt><code>TypeError</code></dt>
 <dd>No parameter is specified or the <code>type</code> is not that of the {{domxref("ClipboardItem")}}.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>In the following example, we're returning all items on the clipboard via the {{domxref("clipboard.read()")}} method. Then utilizing the {{domxref("ClipboardItem.types")}} property to set the <code>getType()</code> argument and return the corresponding blob object.</p>

<pre class="brush: js notranslate">async function getClipboardContents() {
  try {
    const clipboardItems = await navigator.clipboard.read();

    for (const clipboardItem of clipboardItems) {

      for (const type of clipboardItem.types) {
        const blob = await clipboardItem.getType(type);
        // we can now use blob here
      }

    }

  } catch (err) {
    console.error(err.name, err.message);
  }
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Clipboard API','#clipboarditem','ClipboardItem')}}</td>
   <td>{{Spec2('Clipboard API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ClipboardItem.getType")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Clipboard_API">Clipboard API</a></li>
 <li><a href="https://async-clipboard-api.glitch.me/">Async Clipboard API demo on Glitch</a></li>
 <li><a href="https://web.dev/image-support-for-async-clipboard/">Image support for Async Clipboard article</a></li>
</ul>
